/**
 * Copyright 2017 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { GoogleAuth } from './auth/googleauth';
export { Compute } from './auth/computeclient';
export { GoogleAuthOptions } from './auth/googleauth';
export { IAMAuth } from './auth/iam';
export { JWTAccess } from './auth/jwtaccess';
export { JWT } from './auth/jwtclient';
export { CodeChallengeMethod, OAuth2Client } from './auth/oauth2client';
export { UserRefreshClient } from './auth/refreshclient';
export { DefaultTransporter } from './transporters';
declare const auth: GoogleAuth;
export { auth, GoogleAuth };
